<template>
  <example-wrapper v-if="!loading" class="-mbl">
    <component :is="componentName" v-bind="activeProps" v-model="internalValue">
      <!-- eslint-disable vue/v-slot-style -->
      <template v-for="name in activeSlots" :key="name" v-slot:[name]>
        <v-html :html="slotValues[name]" />
      </template>
      <!-- eslint-enable vue/v-slot-style -->
    </component>

    <template v-if="doc.playground.bindValue" #aside>
      <pre><strong>Value:</strong> {{ internalValue }}</pre>
    </template>
  </example-wrapper>
  <rui-loading v-else text="Loading component..." />

  <div class="_filters">
    <div class="_filters__section">
      <div class="_filters__section__title">Presets</div>
      <select v-model="selectedPreset" :disabled="Object.keys(presets).length === 1">
        <option v-for="name in Object.keys(presets)" :key="name" :value="name">{{ name }}</option>
      </select>
    </div>
  </div>

  <div class="-grid-2 -grid--gap">
    <div>
      <h2>Props</h2>

      <rui-empty v-if="doc.props.length === 0" icon="info" inline>This component has no props</rui-empty>

      <table>
        <tr v-for="prop in doc.props" :key="prop.name">
          <td class="-text--right"><code>{{ prop.name }}</code></td>
          <td>
            <rui-icon-text v-if="doc.playground.disabledProps.includes(prop.name)"
                           variant="mute"
                           text="This prop is disabled in the playground"
                           size="small"
                           icon="warning" />
            <prop-control v-else v-model="propValues[prop.name]" :prop="prop" />
          </td>
        </tr>
      </table>
    </div>

    <div>
      <h2>Slots</h2>

      <rui-empty v-if="doc.slots.length === 0" icon="info" inline>This component has no slot</rui-empty>

      <rui-form v-else
                :cancellable="false"
                :disable-submit="loading"
                submit-button-icon="check"
                submit-button-title="Apply changes"
                @submit.prevent="applySlotChanges">
        <table>
          <tr v-for="slot in doc.slots" :key="slot.name">
            <td class="-text--right">
              <label :for="`slot_${slot.name}`"><code>{{ slot.name }}</code></label>
            </td>
            <td>
              <textarea :id="`slot_${slot.name}`" v-model="formSlotValues[slot.name]" :name="slot.name" rows="3" />
              <markdown-renderer v-if="slot.description" class="rui-field__help" :raw="slot.description" />
            </td>
          </tr>
        </table>
      </rui-form>
    </div>
  </div>
</template>

<script>
import VHtml from './VHtml.js'

import ExampleWrapper from './ExampleWrapper.vue'

import PropControl from './PropControl.vue'
import MarkdownRenderer from './MarkdownRenderer.vue'

export default {
  name: 'ComponentPlayground',
  components: { MarkdownRenderer, PropControl, ExampleWrapper, VHtml },
  props: {
    componentName: { required: true, type: String },
    modelValues: { required: false, type: Object, default: () => ({}) },
  },
  data () {
    // const presets = completePresets(this.componentName)
    const doc = this.$getDoc(this.componentName)
    let internalValue = null
    if (Object.hasOwnProperty.call(doc.playground, 'bindValue')) {
      internalValue = doc.playground.bindValue
    }
    return {
      loading: false,
      doc,
      presets: doc.playground.presets,
      selectedPreset: Object.keys(doc.playground.presets)[0],
      // Forms
      propValues: {},
      slotValues: {},
      formSlotValues: {},
      internalValue,
    }
  },
  computed: {
    // If props are not filtered, entries with empty values will still be bound, resulting in the empty slot being
    // used
    activeSlots () {
      return Object.keys(this.slotValues).filter(k => {
        if (this.slotValues[k] === null) return false

        return this.slotValues[k].trim() !== ''
      })
    },
    // If props are not filtered, entries with null or empty values will still be bound, resulting in the defaults not
    // applying on the component
    activeProps () {
      const props = {}

      Object.keys(this.propValues).filter(k => !(this.propValues[k] === null || this.propValues[k] === ''))
        .forEach((k) => { props[k] = this.propValues[k] })

      return props
    },
  },
  methods: {
    applySlotChanges () {
      this.loading = true
      this.slotValues = { ...this.formSlotValues }
      this.$nextTick(() => {
        this.loading = false
      })
    },
    apply (presetName) {
      this.loading = true

      const preset = { ...this.presets[presetName] }

      // Props
      const propValues = {}
      if (this.doc.props) {
        this.doc.props.forEach((p) => {
          if (Object.prototype.hasOwnProperty.call(preset.props, p.name)) {
            propValues[p.name] = preset.props[p.name]
          } else {
            propValues[p.name] = null
          }
        })
      }

      // Slots
      const slotValues = {}
      if (this.doc.slots) {
        this.doc.slots.map(p => p).forEach((p) => {
          if (Object.prototype.hasOwnProperty.call(preset.slots, p.name)) {
            slotValues[p.name] = preset.slots[p.name]
          } else {
            slotValues[p.name] = null
          }
        })
      }
      this.propValues = propValues
      this.formSlotValues = { ...slotValues }
      this.slotValues = slotValues
      this.$nextTick(() => { this.loading = false })
    },
  },
  created () {
    this.apply(this.selectedPreset)
  },
  watch: {
    selectedPreset (newValue, oldValue) {
      if (newValue !== oldValue) this.apply(newValue)
    },
  },
}
</script>
